<?php
include_once ("dap-config.php");

$req = 'cmd=_notify-validate';
foreach ($_REQUEST as $key => $value) {
	$value = urlencode(stripslashes($value));
	$req .= "&$key=$value";
	logToFile("dap-1shopcart: " . $key . "=" . $value, LOG_DEBUG_DAP);
}

logToFile($req);


$txn_num = 0;
$i=1;
$post = array();
foreach($_REQUEST as $key=>$value)
{
	$post[$key] = $value;
}
$post['payment_processor'] = '1shopcart';
$existingUser = false;

if ( !isset($post['payer_email']) || $post['payer_email'] == '' )
	$post['payer_email'] = $post['email1'];

$autoLogin = "Y";

while (true) {
	if(strcmp($post['status'],"Accepted") == 0) {
		
		if ($i == 1) {
			$user = Dap_User::loadUserByEmail($post['payer_email']);
			if (isset($user)) { $autoLogin = "N"; }
		}
		
		$post['item_name'] = isset($_REQUEST['product' . $i]) ? $_REQUEST['product' . $i] : '';
			
		if ($post['item_name'] == "") {
			break;
		}
		
    	$post['quantity'] = isset($_REQUEST['quantity' . $i]) ? $_REQUEST['quantity' . $i] : '';
	
		if(isset($post['price' . $i]))
			$post['mc_gross'] = $post['price' . $i];
		
//			$post['txn_id'] = $post['orderID'] . "-" . $i;

		$post['txn_id'] = $post['orderID'];
		
		if ($i > 1) {
			$post['txn_id'] = $post['orderID'] . "-" . $i;
		}
		
		process1shopcartResponse($req, $post, $i);
		$i++;
		$txn_num++;
	}
	else {
		$dap_error = "payment not accepted: params=" . 	$req;
		logToFile("dap-1shopcart: " . $dap_error, LOG_DEBUG_DAP);
		sendAdminEmail("dap-1shopcart:payment not accepted", $dap_error);
		$redirect = $post['failredirect'];
		$msg = "Payment failed! Please check your email for further details.";
		$redirURL =  $redirect . "?msg=" . $msg;
		header("Location: " . $redirURL);
		return;	
	}
}


$user = Dap_User::loadUserByEmail($post['payer_email']);

if(isset($user) && ($autoLogin == "Y")) {
	logToFile("dap-1shopcart.php: redirecting to authenticate.php to auto login user". $record_id);
		
	if (isset($post['redirect'])) {
		logToFile("dap-1shopcart.php: redirecting to". $post['redirect']);
		header("Location: /dap/authenticate.php?email=" . $post['email1'] . "&password=" . $user->getPassword() . "&submitted=Y&request=".$post['redirect']);
	}
	else {
		header("Location: /dap/authenticate.php?email=" . $post['email1'] . "&password=" . $user->getPassword() . "&submitted=Y");
	}
}
else {
	logToFile("dap-1shopcart.php: user already exists.. do not auto-login". $record_id);
	$redirect = Dap_Config::get("LOGIN_URL");
	$msg = "SUCCESS! Thank you for the purchase. Please check your email for further details.";
	$redirURL =  $redirect . "?msg=" . $msg;
	header("Location: " . $redirURL);
}

logToFile("dap-1shopcart.php: EXITING...");
return;

function process1shopcartResponse($req, $post) 
{
	//translate
	
	logToFile("dap-1shopcart: process1shopcartResponse", LOG_DEBUG_DAP);
	
	if (securityCheck($post) == -1) {
		return;
	}
	
	$post['txn_type'] = $post['msgType'];
	
	if ($post['item_name'] == "") {
		$dap_error = "missing product name in the 1shopcart notification for the user: " . $post['email1'];
		logToFile("dap-1shopcart: " . $dap_error, LOG_DEBUG_DAP);
		sendAdminEmail("dap-1shopcart: missing product name in the 1shopcart notification", $dap_error);
		return;
	}
	
	//$post['txn_id'] = $post['orderID'];
	$post['txn_type'] = "cart";
	$fullname = explode(" ", $post['name']);
	$post['first_name'] = $fullname[0];
	$post['last_name'] = $fullname[1];
	
	/*
	$post['address1'] = $post['address1'];
	$post['city'] = $post['city'];
	$post['state'] = $post['state'];
	$post['zip'] = $post['zip'];
	$post['country'] = $post['country'];
	$post['phone'] = $post['phone'];
	*/
	
	$post['ship_to_first_name'] = $post['shipname'];
	$post['ship_to_address1'] = $post['shipAddress1'];
	$post['ship_to_city'] = $post['shipCity'];
	$post['ship_to_state'] = $post['shipState'];
	$post['ship_to_zip'] = $post['shipZip'];
	$post['ship_to_country'] = $post['shipCountry'];
	
// 	$post['mc_currency'] = $post['currency'];
	$post['mc_currency'] ='USD';
	
	if ( !isset($post['payer_email']) || $post['payer_email'] == '' )
		$post['payer_email'] = $post['email1'];

	$post['item_number'] = "1";
	
	if(!isset($post['payment_status'])) { 
		$post['payment_status'] = 'Completed';
	}
	
	logToFile("dap-1shopcart: process1shopcartResponse - calling recordIncoming", LOG_DEBUG_DAP);
	
	$record_id = Dap_PaymentProcessor::recordIncoming($post);
	
	logToFile("dap-1shopcart.php: recorded incoming 1shopcart. id:". $record_id);
	//$original_request = $req;
	// post back to PayPal system to validate
	
	if ($record_id != -1) {
		//finally process the transaction
		Dap_Transactions::setRecordStatus($record_id, 1);
		Dap_Transactions::processTransaction($record_id);
	}
	
return;
}

function securityCheck($post) {
	logToFile("dap-1shopcart.php: running securityCheck");
	logToFile("dap-1shopcart.php: post cartId = " . $post['cartId']);
	logToFile("dap-1shopcart.php: config cartId = " . Dap_Config::get('SECRET_KEY'));
	
	if (strcmp($post['cartId'],Dap_Config::get('SECRET_KEY')) != 0) {
		$dap_error = "security check failed: the cartId in payment notification does not match the cartId set in dap for the user = " . $post['email'];
		logToFile("dap-1shopcart: " . $dap_error);
		sendAdminEmail("dap-1shopcart: security check failed", $dap_error);
		return -1;
	}
	logToFile("dap-1shopcart.php: securityCheck successfully completed", LOG_DEBUG_DAP);
	return 0;
}


?>
