<?php

define('CHUNK_SIZE', 1024*1024); // Size (in bytes) of tiles chunk						

	function getIpOfUser() {
		$ip = "";
		if (isset($_SERVER['HTTP_X_FORWARD_FOR'])) {
			$ip = $_SERVER['HTTP_X_FORWARD_FOR'];
		} else {
			$ip = $_SERVER['REMOTE_ADDR'];
		}
		logToFile("ip address: $ip",LOG_INFO_DAP);
		return $ip;
	}

	function validate($email, $user_password) {
		$authenticated = FALSE;
		logToFile("Validate Login:".$email);
		if ( ($email != "") && ($user_password != "") ) {
			$user = Dap_User::authenticateUser($email, $user_password);
			if(!empty($user)) {
				logToFile("Authenticated....",LOG_DEBUG_DAP); 
				$authenticated = TRUE;
				$session = Dap_Session::getSession();
				$user = Dap_User::loadUserByEmail($email);
				$session->setUser($user);
				$_SESSION['dap_session'] = $session;
				//for external systems - wordpress, etc
				$_SESSION['dap_first_name'] = $user->getFirst_name();
				$_SESSION['dap_email'] = $user->getEmail();
				$_SESSION['dap_member_home_page'] = Dap_Config::get("MEMBER_HOME_PAGE");
				//$_SESSION['dap_password'] = $user->getPassword();
			}
		}
		logToFile("User Authenticated:".$email.":".$authenticated,LOG_INFO_DAP);
		return $authenticated;
	}

	/**
		Authenticate the request url.
		Return TRUE if authorized.
		Return FALSE if not authorized.


		Note: This function need to return as fast as it could possibly.
			Return TRUE (authorized)  could possibly mean the resource is OPEN .
			Use this function ONLY to decide to serve up the url or not.
		NOTE: This method assumes relatively short session times and DOES NOT consider
			situations such as a resource becoming protected between the time it was OPEN and the time user access it.
			Basic data sync between session and database issues need to be resolved.
		NOTE: requestUrl should be cleanced enough not to create situations where user can craft it such that it can become array of entries.
	**/

	function isURLAllowed($requestUrl) {

		$ERROR_CODES = array(
							"DAP001" => "Sorry, you do not have access to this content.",
							"DAP002" => "Sorry, your access to this content has expired.",
							"DAP003" => "Sorry, this content is not yet available to you.",
							"DAP004" => "Sorry, your access to this content has expired.",
							"DAP005" => "Sorry, this is premium content available only to paid members.",
							"DAP006" => "Sorry, this is Members-Only content. Please login to access this..."
						);
		
		$lockImage = "/dap/images/lock.gif";
		
		if( file_exists($_SERVER['DOCUMENT_ROOT'] . "/dap/images/customlock.gif") ) {
			$lockImage = "/dap/images/customlock.gif";
		} else if( file_exists($_SERVER['DOCUMENT_ROOT'] . "/dap/images/customlock.jpg") ) {
			$lockImage = "/dap/images/customlock.jpg";
		}
		
		$TEXT_CODES = array(
							"DAP001" => "<img src='" . $lockImage . "' align='center'><h2>Sorry, you do not have access to this content.</h2>",
							"DAP002" => "<img align='center' src='" . $lockImage . "'><h2>Sorry, your access to this content has expired.</h2>",
							"DAP003" => "<img align='center' src='" . $lockImage . "'><h2>Sorry, this content is not yet available to you.</h2>",
							"DAP004" => "<img align='center' src='" . $lockImage . "'><h2>Sorry, your access to this content has expired.</h2>",
							"DAP005" => "<img align='center' src='" . $lockImage . "'><h2>Sorry, this is premium content available only to paid members.</h2>",
							"DAP006" => "<img align='center' src='" . $lockImage . "'><h2>Sorry, this is Members-Only content</h2>"
						);							

		$resource = new Dap_FileResource();
		$resource->setUrl($requestUrl);

		if(!isset($requestUrl)) {
			$requestUrl = $_SERVER['REQUEST_URI'];
			//logToFile("Request URI:".$requestUrl);
		}
		//logToFile("--------------------------");
		//logToFile("Request URI:".$requestUrl);
		//check if the requestUrl is part of already authenticated urls list from session.
		$cache = Dap_Config::get("ACCESS_CACHE_CONTROL_DB");
		//logToFile("DB Cache ?:".$cache);
		try {
			//if( ($cache == 'Y') && isUrlInSession($requestUrl) ) {
				//return $resource;
				//return TRUE;
			//}
			//if the url is not protected, then add it to session.
			if(!Dap_Resource::isResourceProtected($requestUrl)) {
				//addUrlToSession($requestUrl,TRUE);
				//logToFile("This URI is OPEN:".$requestUrl);
				return $resource;
				//return TRUE;
			}
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			$resource->setError_id("DAP004");
			$resource->addError($ERROR_CODES["DAP004"]);
			$resource->addError(getErrorPageByResource($requestUrl));
			$resource->addError($TEXT_CODES["DAP004"]);
			return $resource;
		}	
		//we are at stage where url is protected and we need to decide if we let this user access the resource.
		// Either user purchased a product and expired access
		//   Or user did not purchase the product
		//lets check purchased products to see if this request qualifies
		// NOTE:  For now we assume user id is  'uid' in session.
		$session = Dap_Session::getSession();
		$user = $session->getUser(); ////Dap_User::loadLoggedInUser();
		$uid = NULL;
		if(is_null($user)) {
			//Check if feed user
			if(defined('DAP_FEED_USER_ID')) {
				$uid = DAP_FEED_USER_ID;
			} else {
				//logToFile("No user found or User Is Not Logged In..");
				$resource->setError_id("DAP006");
				$resource->addError($ERROR_CODES["DAP006"]);
				$resource->addError(Dap_Config::get("LOGIN_URL"));
				$resource->addError($TEXT_CODES["DAP006"]);
				//$resource->addError(getErrorPageByResource($requestUrl));
				return $resource;
				//$_SESSION['ERROR'] = $ERROR_CODES["DAP006"];
				//$_SESSION['ERROR_URL'] = getErrorPageByResource($requestUrl);
				//return FALSE;
			}
		} else {
			$uid = $user->getId();
		}
		//NOTE: the following query should result in only one resource. If we get multiple, just take first one.
		//implement simple logic to loop thru and give access if you can. Or route to last product error pages.
		$sql = "select
					upj.transaction_id as transid,
					TO_DAYS(now()) as today,
					TO_DAYS(upj.access_start_date) as access_start_days,
					TO_DAYS(upj.access_end_date) as access_end_days,
					prj.is_free as is_free,
					prj.start_day as start_day,
					prj.end_day as end_day,
					TO_DAYS(prj.start_date) as res_start_days,
					TO_DAYS(prj.end_date) as res_end_days,
					prj.num_clicks as num_clicks,
					prj.product_id as product_id,
					prj.resource_id as resource_id,
					prj.credits_assigned as credits_assigned,
					p.error_page_url as error_page_url
			from
				dap_products p,
				dap_products_resources_jn prj,
				dap_file_resources fr,
				dap_users u,
				dap_users_products_jn upj
			where
				u.id =:uid and
				u.status = 'A' and
				fr.url =:requesturl and
				prj.resource_id = fr.id and
				prj.resource_type = 'F' and
				prj.status = 'A' and
				p.id = prj.product_id and
				p.status = 'A' and
				upj.user_id = u.id and
				upj.product_id = p.id and
				upj.status = 'A' and
				(
					(
						prj.start_day != 0 and
						( (TO_DAYS(now()) - TO_DAYS(upj.access_start_date) + 1) >= prj.start_day ) and
						( (TO_DAYS(now()) - TO_DAYS(upj.access_end_date) + 1) <= prj.end_day)
					) 
					or
					(
						prj.start_date != 0 and
						( date(now()) >= prj.start_date )
					) 
					or
					(
						( date(now()) >= upj.access_start_date ) and
						( date(now()) <= upj.access_end_date )
					) 
				)
			order by
				upj.access_end_date desc,
				prj.end_day desc,
				access_end_days desc,
				prj.num_clicks asc
				";
			//	now() between upj.access_start_date and upj.access_end_date	and
			//	(TO_DAYS(NOW()) - TO_DAYS(access_start_date)) between prj.start_day and prj.end_day

		//echo "sql: $sql<br>"; exit;
		//logToFile("SQL:".$sql);
		$dap_dbh = Dap_Connection::getConnection();
		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':uid', $uid, PDO::PARAM_INT);
		$stmt->bindParam(':requesturl', $requestUrl, PDO::PARAM_STR);
		$stmt->execute();
		//$result = mysql_query($sql) or trigger_error("Database Error",E_USER_WARNING);
		/*
			Single resource can be assigned to multiple products.
			We need to loop thru each product resource relationship and see if any row is eligible for access.

			We do series of checks to if url is blocked. If any test decides its blocked, we goto next item in loop.
			If none of the tests for a single row decides its blocked, then we break the loop and give access.

		*/
		$post_cancel_access = Dap_Config::get("POST_CANCEL_ACCESS");
		if(isset($post_cancel_access)) {
			$post_cancel_access = strtolower($post_cancel_access);
		}
		//$post_cancel_access = Dap_Config::
		while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {

			//we have atleast one product that user signed up
			// NOTE: SIGNUP IS DIFFERENT FROM PAID.
			//logToFile("Today:".$row["today"]);
			//echo "<br>";
			//logToFile("Product Access Start Days:".$row["access_start_days"]);
			//echo "<br>";
			//logToFile("Product Access End Days:" . $row["access_end_days"]);
			//echo "<br>";
			//logToFile("Resource Start Day:" . $row["start_day"]);
			//echo "<br>";
			//logToFile("Resource End Day:" . $row["end_day"]);
			//echo "<br>";
			//logToFile("Resource Start (Date)DAYS:" . $row["res_start_days"]);
			//echo "<br>";
			//logToFile("Resource End (Date)DAYS:" . $row["res_end_days"]);
			//echo "<br>";
			//logToFile("Product Resource Num Clicks:" . $row["num_clicks"]);
			//echo "<br>";

			//product is SIGNUP only, then check if resource is free
			// -1 - direct sign up for free resources
			// -2 - admin sign up - for free resources
			// -3 - admin paid sign up - for all resources
			if((($row["transid"] == "-2") || ($row["transid"] == "-1")) && (strtolower($row["is_free"]) != "y")) {
				//logToFile("Not Free Resource, but User is FREE...");
				$resource->setError_id("DAP005");
				$resource->addError($ERROR_CODES["DAP005"]);
				$resource->addError( $row['error_page_url']);
				$resource->addError($TEXT_CODES["DAP005"]);
				continue;
				//return $resource;
				//$_SESSION['DAP_ERROR'] = $ERROR_CODES["DAP005"];
				//$_SESSION['DAP_ERROR_URL'] = $row['error_page_url'];
				//return FALSE;
			}

			//lets present two modes of operation 
			
			if($post_cancel_access == 'y') {
				//logToFile("Post cancel = Y"); 
				
				//Product did not launch yet.
				if($row["today"] < $row["access_start_days"]) {
					//logToFile("Product Start Date is in future...");
					$resource->setError_id("DAP001");
					$resource->addError($ERROR_CODES["DAP001"]);
					$resource->addError( $row['error_page_url']);
					$resource->addError($TEXT_CODES["DAP001"]);
					continue;
				}
				
				//logToFile("SSS:  uid:".$uid." product_id:".$row["product_id"].":resource_id:".$row["resource_id"]);
				// ADDED FOR SSS - 05/14/2011
				if(($row["credits_assigned"] != NULL) && ($row["credits_assigned"] > 0)) {
					// check user credits
					//logToFile("SSS:  uid:".$uid." product_id:".$row["product_id"].":resource_id:".$row["resource_id"]);
					$usercred = Dap_UserCredits::loadCreditsPerResource($uid, $row["product_id"], $row["resource_id"]);
			
					if ( ($usercred == null) || ($usercred == "") ) {
						//logToFile("usercredit missing",LOG_DEBUG_DAP); 
						$resource->setError_id("DAP001");
						$resource->addError($ERROR_CODES["DAP001"]);
						$resource->addError( $row['error_page_url']);
						$resource->addError($TEXT_CODES["DAP001"]);
						continue;	
					}
				}
				//logToFile("row[today]: " . $row["today"]); 
				
				//we have dates on the resource
				if($row["res_start_days"] <> 0 && $row["res_start_days"] <> "" &&
					$row["res_end_days"] <> 0 && $row["res_end_days"] <> "" ) {
					//set resource start days 
					$resource_start_days = $row["res_start_days"];
					$resource_end_days = $row["res_end_days"];
				}
							
				//we have days on the resource
				if($row["start_day"] <> 0 && $row["start_day"] <> "" &&
					$row["end_day"] <> 0 && $row["end_day"] <> "" ) {
					//set resource start days 
					$resource_start_days = $row["access_start_days"] + $row["start_day"] - 1;
					$resource_end_days = $row["access_start_days"] + $row["end_day"] - 1;

					//logToFile("We have 'days' on the resource"); 
					//logToFile("resource_start_days: $resource_start_days"); 
					//logToFile("resource_end_days: $resource_end_days"); 
					//logToFile("User's row[access_start_days]: " . $row["access_start_days"]); 

					/**
						So if resource "days" are hard-coded, but resource end day is in the past,
						then do not allow access. Will help offer expiring bonuses even though post-cancel-access is yes.
					*/
					if($row["today"] > $resource_end_days ) { //Expiring Bonuses
						//logToFile("Sorry: The 'end day' for this content is in the past...");
						$resource->setError_id("DAP001");
						$resource->addError($ERROR_CODES["DAP001"]);
						$resource->addError( $row['error_page_url']);
						$resource->addError($TEXT_CODES["DAP001"]);
						continue;
					}
				}
				//logToFile("Resource Start Days:".$resource_start_days);
				//logToFile("Resource End Days:".$resource_end_days);
				
				//if resource starts in future, lets not grant access.
				if($row["today"] < $resource_start_days ) {
					//logToFile("Resource Start Date is in future...");
					$resource->setError_id("DAP001");
					$resource->addError($ERROR_CODES["DAP001"]);
					$resource->addError( $row['error_page_url']);
					$resource->addError($TEXT_CODES["DAP001"]);
					continue;
				}					

				//
				// If resource ends before upj start date - then no acesss. This could only happen 
				//    when calendar dates are used at the resource level.
				// If resource starts after upj end date - then no access. This could only happen
				//    when calendar dates are used at the resource level.
				//
				//
				if( ($resource_end_days < $row["access_start_days"]) || ($resource_start_days > $row["access_end_days"]) ) {
					//logToFile("Product Start Date is in future...");
					//logToFile("Access Start Days:".$row["access_start_days"]);
					//logToFile("Access End Days:".$row["access_end_days"]);
					$resource->setError_id("DAP005");
					$resource->addError($ERROR_CODES["DAP005"]);
					$resource->addError( $row['error_page_url']);
					$resource->addError($TEXT_CODES["DAP005"]);
					continue;						
				}				
			
			} else { //Post Cancel = "N"
				
				//Product did not lauch yet.
				if($row["today"] < $row["access_start_days"]) {
					//logToFile("Product Start Date is in future...");
					$resource->setError_id("DAP001");
					$resource->addError($ERROR_CODES["DAP001"]);
					$resource->addError( $row['error_page_url']);
					$resource->addError($TEXT_CODES["DAP001"]);
					continue;
					//return $resource;
					//$_SESSION['DAP_ERROR'] = $ERROR_CODES["DAP001"];
					//$_SESSION['ERROR_URL'] = $row['error_page_url'];
					//return FALSE;
				}
				//Product expired
				if($row["today"] > $row["access_end_days"]) {
					//logToFile("Product End Date is in past...");
					$resource->setError_id("DAP002");
					$resource->addError($ERROR_CODES["DAP002"]);
					$resource->addError( $row['error_page_url']);
					$resource->addError($TEXT_CODES["DAP002"]);
					continue;
					//return $resource;
					//$_SESSION['DAP_ERROR'] = $ERROR_CODES["DAP002"];
					//$_SESSION['DAP_ERROR_URL'] = $row['error_page_url'];
					//return FALSE;
				}
				//logToFile("SSS:  uid:".$uid);
				
				//logToFile("SSS:  uid:".$uid." product_id:".$row["product_id"].":resource_id:".$row["resource_id"]);
				// ADDED FOR SSS - 05/14
				if(($row["credits_assigned"] != NULL) && ($row["credits_assigned"] > 0)) {
					// check user credits
					//logToFile("SSS:  uid:".$uid." product_id:".$row["product_id"].":resource_id:".$row["resource_id"]);
					$usercred = Dap_UserCredits::loadCreditsPerResource($uid, $row["product_id"], $row["resource_id"]);
			
					if (($usercred != null) && ($usercred != "")) {
						//logToFile("usercredit row exists",LOG_DEBUG_DAP); 
						
					}
					else {
						//logToFile("usercredit missing",LOG_DEBUG_DAP); 
						$resource->setError_id("DAP001");
						$resource->addError($ERROR_CODES["DAP001"]);
						$resource->addError( $row['error_page_url']);
						$resource->addError($TEXT_CODES["DAP001"]);
						continue;	
					}
				} else {  //added upto here for SSS
				
					//product is available.
					//check start date(days).
					if($row["res_start_days"] <> 0 && $row["res_start_days"] <> "" &&
						$row["res_end_days"] <> 0 && $row["res_end_days"] <> "" ) {
		
						//resource is available in future.
						if($row["today"] < $row["res_start_days"]) {
							//logToFile("Resource Start Date  is in future...");
							$resource->setError_id("DAP003");
							$resource->addError($ERROR_CODES["DAP003"]);
							$resource->addError( $row['error_page_url']);
							$resource->addError($TEXT_CODES["DAP003"]);
							continue;
						}
						//resource  expired.
						if($row["today"] > $row["res_end_days"]) {
							//logToFile("Resource End Date  is in past...");
							$resource->setError_id("DAP004");
							$resource->addError($ERROR_CODES["DAP004"]);
							$resource->addError( $row['error_page_url']);
							$resource->addError($TEXT_CODES["DAP004"]);
							continue;
						}
		
					} //else {
						//logToFile("Start Days(Date) and End Days(Date) are empty or ZERO.. not checking...");
					//}
					//check start day
					$lag_days = $row["today"] - $row["access_start_days"] + 1;
					//check resource start and end day only if they are both non zero. 
					if($row["start_day"] <> 0 && $row["start_day"] <> "" &&
						$row["end_day"] <> 0 && $row["end_day"] <> "" ) {
		
						//resource is available in future.
						if($lag_days < $row["start_day"]) {
							$resource->setError_id("DAP003");
							$resource->addError($ERROR_CODES["DAP003"]);
							$resource->addError( $row['error_page_url']);
							$resource->addError($TEXT_CODES["DAP003"]);
							continue;
							//return $resource;
							//$_SESSION['DAP_ERROR'] = $ERROR_CODES["DAP003"];
							//$_SESSION['DAP_ERROR_URL'] = $row['error_page_url'];
							//return FALSE;
						}
						//resource availability expired.
						if($lag_days > $row["end_day"]) {
							//logToFile("Lag Days:".$lag_days);
							//logToFile("End Days:".$row["end_day"]);
							$resource->setError_id("DAP004");
							$resource->addError($ERROR_CODES["DAP004"]);
							$resource->addError( $row['error_page_url']);
							$resource->addError($TEXT_CODES["DAP004"]);
							continue;
							//return $resource;
							//$_SESSION['DAP_ERROR'] = $ERROR_CODES["DAP004"];
							//$_SESSION['DAP_ERROR_URL'] = $row['error_page_url'];
						//return FALSE;
						}
					} //else {
						//logToFile("Start Day and End Day are empty or ZERO.. not checking...");
					//}
					//resource is available in future.
				} /// SSS - end else
			}
			//grant access - we should reach here ONLY IF THE PRODUCT RESOURCE RELATIONSHIP IS CLEAN AND ALLOWED.
			try {
				//logToFile("About to call addUrlToSession()"); 
				//addUrlToSession($requestUrl, FALSE);
			} catch (Exception $e) {
				logToFile($e->getMessage(),LOG_FATAL_DAP);
				$resource->setError_id("DAP004");
				$resource->addError($ERROR_CODES["DAP004"]);
				$resource->addError(getErrorPageByResource($requestUrl));
				$resource->addError($TEXT_CODES["DAP004"]);
			}
			//reset any Resource errrors detected in previous loops and clear them before we return true.
			return $resource;
			//return TRUE;
		}


		//else {
			//we have some product that has this resource, but user did not sign up for it yet.
		//	$_SESSION['DAP_ERROR'] = $ERROR_CODES["DAP005"];
		//	$_SESSION['DAP_ERROR_URL'] = getErrorPageByResource($requestUrl); //$row['error_page_url'];
			//return FALSE;
		//}
		//now check if we have any error messages. If we do, that means we failed access check - no access.
		$errId = $resource->getError_id();
		if(!isset($errId)) {
			//we have some product that has this resource, but user did not sign up for it yet.
			$resource->setError_id("DAP005");
			$resource->addError($ERROR_CODES["DAP005"]);
			$resource->addError(getErrorPageByResource($requestUrl));
			$resource->addError($TEXT_CODES["DAP005"]);
		}
		return $resource;
	}

	function isUrlInSession($requestUrl) {
		//check open url session array
		$urls = Dap_Session::get(SN_OPEN_URIS);
		if(isset($urls)) {
			//get array of authenticated urls
			$Authenticated_URLs = $urls;
			if (in_array($requestUrl, $Authenticated_URLs)) {
				//echo "URLAllowed from SESSION.<br>";
				//logToFile("Allow URL From Session:".$requestUrl);
				return TRUE;
			}
		}
		//check Authenticated urls
		$urls = Dap_Session::get(SN_AUTH_URIS);
		if(isset($urls)) {
			//get array of authenticated urls
			$Authenticated_URLs = $urls;
			if (in_array($requestUrl, $Authenticated_URLs)) {
				//echo "URLAllowed from SESSION.<br>";
				logToFile("Allow URL From Session:".$requestUrl);
				//lets do the resource check only on auth urls
				$session = Dap_Session::getSession();
				$user = $session->getUser(); 
				//if($user != NULL && isset($user)) {
					//Dap_Resource::isResourceClickCountOK($user->getId(), $requestUrl);
				//}
				return TRUE;
			}
		}		//
		return FALSE;
	}

	/*
	This adds a given url to session cache.
	If $open is TRUE, then it adds to cache of open urls
	If $open is FALSE, then it adds to cache of protected urls. - THIS SECURITY SHOULD HAVE BEEN CHECKED ALREADY.

	*/
	function addUrlToSession($requestUrl,$open) {
		logToFile("Adding URL To Session:".$requestUrl);
		if($open) {
			$urls = Dap_Session::get(SN_OPEN_URIS);
			if(isset($urls)) {
				$Open_URLs = $urls;
				array_push($Open_URLs,$requestUrl);
				Dap_Session::set(SN_OPEN_URIS,$Open_URLs);
			} else {
				$Open_URLs = array();
				array_push($Open_URLs,$requestUrl);
				Dap_Session::set(SN_OPEN_URIS,$Open_URLs);
			}
		} else {
			$urls = Dap_Session::get(SN_AUTH_URIS);
			if(isset($urls)) {
				$Authenticated_URLs = $urls;
				array_push($Authenticated_URLs,$requestUrl);
				Dap_Session::set(SN_AUTH_URIS,$Authenticated_URLs);
			} else {
				$Authenticated_URLs = array();
				array_push($Authenticated_URLs,$requestUrl);
				Dap_Session::set(SN_AUTH_URIS,$Authenticated_URLs);
			}
			//lets do the resource check only on auth urls
			//$session = Dap_Session::getSession();
			//$user = $session->getUser(); 
			//if($user != NULL && isset($user)) {
				//Dap_Resource::isResourceClickCountOK($user->getId(), $requestUrl);
			//}
			//TODO INCREMENT CLICK COUNT
			//Dap_UserResource::incClick_count($_SESSION[Dap_Config::getSession_user_id()]);
		}
	}




	/*
		Return a product error page given a resource url.
		Look up resource url into product_resource_jn and then lookup product to deduce the error page url.
		Always take only records that are Active (A)
		If nothing is found, then return site level error page.

	*/
	function getErrorPageByResource($requestUrl) {
		return Dap_Product::getErrorPageByResource($requestUrl);
	}


	// Read a file and display its content chunk by chunk
	if( !function_exists("readfile_chunked_dap") ) {
		function readfile_chunked_dap($filename, $retbytes = TRUE) {
			$buffer = '';
			$cnt =0;
			//$handle = fopen($filename, 'rb');
			$handle = fopen($filename, 'rb');
			if ($handle === false) {
			  return false;
			}
			while (!feof($handle)) {
				$buffer = fread($handle, CHUNK_SIZE);
				echo $buffer;
				ob_flush();
				flush();
				if ($retbytes) {
					$cnt += strlen($buffer);
				}
			}
			$status = fclose($handle);
			if ($retbytes && $status) {
			  return $cnt; // return num. bytes delivered like readfile() does.
			}
			return $status;
		}
	}


	/*
	//Serve the file requested.
	// If the file type if php, then include it.
	*/


	function serveFile($filename) {
		$filename = trim($filename, '/');
		$filename = DAP_ROOT . "../" . $filename;
	 	logToFile("Serving...*".$filename."*");
	 	logToFile("Directory Of Request...*".dirname($filename)."*");
		$cwdname = dirname($filename);
		if (!file_exists($filename)) {
	 		logToFile("File Not Found..*".$filename."*", LOG_INFO_DAP);
			header('Status: 404 Not Found1');
			header('HTTP/1.0 404 Not Found1');
			return; //die();
			//die("NO FILE HERE");
		}

		$ctype = getMimeType($filename);

		switch ($ctype) {
			//executable php
			case "php":
				$wd_was = getcwd();
				foreach ($_REQUEST as $key => $value) {
					logToFile( "Request:$key => $value" );
				}
				logToFile("Changing Directory To: $cwdname");
				if(chdir($cwdname) === TRUE) {
					logToFile("File Dir Is:".dirname(__FILE__));
					logToFile("Successfully Changed The Dir.".getcwd());
				}
				logToFile("Including Php File: ".basename($filename));
				logToFile("Including Php File: ".$filename);

				//need to set some variables such as php_self as otherwise they will be set to the dapclient php
				$_SERVER['PHP_SELF'] = $_GET['dapref'];
				#include basename($filename);
				//include $absolute_file;
				include $filename;
				chdir($wd_was);
				return;
				break;
		}

		header("Content-Type: $ctype");
		header("Content-Length: ".@filesize($filename));
		if( !ini_get('safe_mode') ){
        	set_time_limit(0);
        } 
		//set_time_limit(0);
		//@readfile("$filename") or die("File not found.");
		@readfile_chunked_dap($filename);
		flush();
    	ob_flush();
	}

	function dapDebug($msg) {
		if(isset($_SESSION['log'])) {
			$log = $_SESSION['log'];
			array_push($log,$msg);
			$_SESSION['log'] = $log;
		} else {
			//$log = array();
			//unset($_SESSION['log']);
			$log = array();
			$_SESSION['log'] = $log;
			logToFile("Init Log.");
		}
	}

	function replaceFillers($fileName, $orig, $dest) {
		$data = file_get_contents($fileName);
		$data = str_replace ($orig, $dest, $data);
		return $data;
	} // End replaceFillers()

	function dapErrorHandler($errnum,$errmsg,$file,$lineno){
	  if($errnum==E_USER_WARNING){
	    echo 'Error: '.$errmsg.'<br />File: '.$file.'<br />Line: '.$lineno;
		//logToFile("createUser:".$sql.":".mysql_error());
	    exit();
	  }
	}

	//get just the resource for dap from a string. String could be just the request_uri or it could be full url
	function getResourceFromString($url) {
		$url = @parse_url($url, PHP_URL_PATH);
		//echo $url;
		$url = rawurldecode($url);
		//echo $url;
		$parse_vars = explode("&",$url);
		//parse_str($url, $parse_vars);
		//print_r($parse_vars);
		//$keys = array_keys($parse_vars);
		//$url = $keys[0];
		$url = $parse_vars[0];
		$url = trim($url, "/");
		$url = trim($url, "_");
		$url = trim($url, " ");
		$url = "/".$url;
		return $url;
	}
	
	function getResourceFromUserRequest() {
		$url = $_SERVER['REQUEST_URI'];
		$file = $_SERVER['SCRIPT_FILENAME'];
		$path_info = $_SERVER['PATH_INFO'];
		$req_uri = $_SERVER['REQUEST_URI'];
		//$req_uri_array = explode('?', $req_uri);
		//$req_uri = $req_uri_array[0];
		//decode the request uri
		//$req_uri = rawurldecode($req_uri);
		//
		//parse_str($req_uri, $parse_vars);
		//print_r($parse_vars);
		//$keys = array_keys($parse_vars);
		//$url = $keys[0];
		//$url = trim($url, "/");
		$url = getResourceFromString($req_uri);
		logToFile("Request Coming In: URI:".$url);
		logToFile("Request Coming In: File:".$file);
		logToFile("Dap Ref:".$_GET['dapref']);
		logToFile("Path Info:".$path_info);
		// build the URL in the address bar
		//$requested_url  = ( isset($_SERVER['HTTPS'] ) && strtolower($_SERVER['HTTPS']) == 'on' ) ? 'https://' : 'http://';
		//$requested_url .= $_SERVER['HTTP_HOST'];
		//$requested_url .= $_SERVER['REQUEST_URI'];
		//logToFile("Request_URL:".$requested_url);
		//$original = @parse_url($requested_url);
		//$url = $original['path'];
		return $url;
	}
	
	function add_include_path ($path)
	{
		foreach (func_get_args() AS $path)
		{
			if (!file_exists($path) OR (file_exists($path) && filetype($path) !== 'dir'))
			{
				trigger_error("Include path '{$path}' not exists", E_USER_WARNING);
				continue;
			}
	
			$paths = explode(PATH_SEPARATOR, get_include_path());
	
			if (array_search($path, $paths) === false)
				array_push($paths, $path);
	
			set_include_path(implode(PATH_SEPARATOR, $paths));
		}
	}
	
	function remove_include_path ($path)
	{
		foreach (func_get_args() AS $path)
		{
			$paths = explode(PATH_SEPARATOR, get_include_path());
	
			if (($k = array_search($path, $paths)) !== false)
				unset($paths[$k]);
			else
				continue;
	
			if (!count($paths))
			{
				trigger_error("Include path '{$path}' can not be removed because it is the only", E_USER_NOTICE);
				continue;
			}
	
			set_include_path(implode(PATH_SEPARATOR, $paths));
		}
	}


	function validateLogins($email, $ip) {
		return Dap_User::authenticateLogins($email, $ip);
	}
	
	function pluginLogin($email) {
		$includeList = array();
		registeredPlugins($includeList, $email, "login");
		
		foreach ($includeList as $key => $value) {
			logToFile( "functions.php : pluginLogin(): " . $key . "=" . $value );
			include_once ($value);
			$forum = new Dap_Vbulletin();
			$errmsg = $forum->login($email);
		}
	}
	
	function pluginLogout() {
		$includeList = array();
		$email="";
		registeredPlugins($includeList, $email, "logout");
		
		foreach ($includeList as $key => $value) {
			logToFile( "functions.php : pluginLogout(): " . $key . "=" . $value );
			include_once ($value);
			$forum = new Dap_Vbulletin();
			$errmsg = $forum->logout();
		}
	}
	
	function registeredPlugins (&$includeList, $email, $action, &$product="") {
		// get the list of all plugins to include based on actiontype (login/add/remove/update)
		if(defined("VBFORUMPATH")) {
			$lldocroot = defined('SITEROOT') ? SITEROOT : $_SERVER['DOCUMENT_ROOT'];
			$filename = $lldocroot . '/dap/plugins/vbulletin/Dap_Vbulletin.class.php';
			if (file_exists($filename)) {
					$includeList[] = 	$filename;
			}
		}
	
		$subscribeList = "";
		if ($product != "") {
			if ($action == "Add") {
				$subscribeList = trim($product->getSubscribeTo());
			}
		 	else if ($action == "Remove") {
				$subscribeList = trim($product->getUnsubscribeFrom());
			}
		}
		
		if($subscribeList == "") return;
			
		$subscribtions = explode(",",$subscribeList);
		foreach ($subscribtions as $subscribeTo) {
			
			logToFile( "functions.php : registeredPlugins(): " . $subscribeTo );
		
			//if (file_exists($filename)) {
					$includeList[] = $subscribeTo;
			//		$path[] = $filename;
			//}
		}
		
		foreach ($includeList as $include) {
				logToFile( "functions.php : registeredPlugins() Plugin Name = : " . $include );
				logToFile( "functions.php : registeredPlugins() Plugin Name = : " . $filename );
		}
	}
	
	function displayTemplate($name) {
      //$data = Dap_Templates::getContentByName("ACTIVATION_EMAIL_CONTENT");
      $data = Dap_Templates::getContentByName($name);
      echo $data;
  	}
	
	
	function removeSlashesDAP($item) { 
		if (get_magic_quotes_gpc() == 0) return($item);
		if (is_array($item)) {
			while(list($k,$v) = each($item)) {
				$item[$k]= removeSlashesDAP($v);
			}
		} else {
			if (is_string($item)) {
				$item= stripslashes($item);
			}
		}
		return($item);
	}  

?>